/**CHeaderFile*****************************************************************

  FileName    [utils.h]

  PackageName [utils]

  Synopsis    [External header of the utils package]

  Description [External header of the utils package.]

  SeeAlso     []

  Author      [Marco Roveri]

  Copyright   [
  This file is part of the ``utils'' package of NuSMV version 2. 
  Copyright (C) 1998-2001 by CMU and ITC-irst. 

  NuSMV version 2 is free software; you can redistribute it and/or 
  modify it under the terms of the GNU Lesser General Public 
  License as published by the Free Software Foundation; either 
  version 2 of the License, or (at your option) any later version.

  NuSMV version 2 is distributed in the hope that it will be useful, 
  but WITHOUT ANY WARRANTY; without even the implied warranty of 
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
  License along with this library; if not, write to the Free Software 
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA.

  For more information of NuSMV see <http://nusmv.irst.itc.it>
  or email to <nusmv-users@irst.itc.it>.
  Please report bugs to <nusmv-users@irst.itc.it>.

  To contact the NuSMV development board, email to <nusmv@irst.itc.it>. ]

  Revision    [$Id: utils.h,v 1.9 2001/11/05 10:57:05 none Exp $]

******************************************************************************/

#ifndef _UTILS_H
#define _UTILS_H

/* These are potential duplicates. */
#ifndef EXTERN
#   ifdef __cplusplus
#	define EXTERN extern "C"
#   else
#	define EXTERN extern
#   endif
#endif
#ifndef ARGS
#   if defined(__STDC__) || defined(__cplusplus)
#	define ARGS(protos)	protos		/* ANSI C */
#   else /* !(__STDC__ || __cplusplus) */
#	define ARGS(protos)	()		/* K&R C */
#   endif /* !(__STDC__ || __cplusplus) */
#endif
#ifndef NORETURN
#   if defined __GNUC__
#       define NORETURN __attribute__ ((__noreturn__))
#   else
#       define NORETURN
#   endif
#endif


#define nusmv_assert(expr) \
assert(expr)

#define NIL_PTR(ptr_type)       \
    ((ptr_type)NULL)

#undef NDEBUG
#include <assert.h>
#include "util.h"
#include "array.h"
#include "avl.h"
#include "ustring.h"
#include "node.h"
#include "assoc.h"
#include "io.h"
#include "error.h"


#include <setjmp.h>
#if SOLARIS
extern sigjmp_buf siglongjmp_buf;
#define SETJMP(buf,val) sigsetjmp(buf, val)
#else
extern jmp_buf siglongjmp_buf;
#define SETJMP(buf,val) setjmp(buf)
#endif
#if SOLARIS
#define LONGJMP(buf,val) siglongjmp(buf, val);
#else
#define LONGJMP(buf,val) longjmp(buf, val);
#endif

#define CATCH set_longjmp_on_err();\
        if (SETJMP(siglongjmp_buf, 1) == 0)

typedef enum {false, true} boolean;


typedef enum outcome_TAG
{
  GENERIC_ERROR, 
  PARSER_ERROR,
  SYNTAX_ERROR, 
  FILE_ERROR, 
  SUCCESS_REQUIRED_HELP, 
  SUCCESS
} outcome;

#endif /* _UTILS_H */



